package org.vtokarev.controller;

import org.vtokarev.domain.User;
import org.vtokarev.service.UserService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * The {@code UserListServlet} class processes GET {@code userList} requests generated by users with ADMIN role.
 * Gets {@link List<User>}, set it as an attribute and forward the control to {@code userList.jsp} view for further processing.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/userList", name = "userListServlet")
public class UserListServlet extends HttpServlet {

    private UserService userService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        userService = (UserService) config.getServletContext().getAttribute("app/UserService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        List<User> users = userService.getAll();
        req.setAttribute("users", users);
        req.getRequestDispatcher("/WEB-INF/jsp/userList.jsp").forward(req, resp);
    }
}